;
; 
;  DS1820 (DS18S20),     "" .
;
;       8.
;
.include	"8535def.inc"

.equ	ds1820_port = PORTD
.equ	ds1820_ddr = DDRD
.equ	ds1820_pin = PIND
.equ	ds1820_bit = 5

.equ	pad = 0x60	;  scrathpad
.equ	rom = 0x68	;  ROM DS1820


;*************************  ***************************
	RJMP	start

;     
segment:
	.DB 0x3f,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F,0x6F,0x00

start:
; 
	LDI  R30,0x5F
	OUT  SPL,R30
	LDI  R30,0x02
	OUT  SPH,R30

;  D
	LDI	R30,0x20
	OUT	PORTD,R30
	LDI	R30,0x3C
	OUT	DDRD,R30

; .
	LDI	R30,0x80
	OUT	ACSR,R30

; DS1820
	RCALL	search	;   ,   R30  .
			;   .
begin:
; 1 
	RCALL	wait_1

;   .
	RCALL	temperature_start

;  
	RCALL	wait_1

; 
	RCALL	temperature_read	;    - R31= 0xAA.

;   
	CPI	R31,0xAA
	BREQ	start

;  
	MOV	R14,R31

;  ,   R30,  BCD 
	CLR	R31
bcd10:	SUBI	R30,10
	BRMI	bcd11
	SUBI	R31,-16
	RJMP	bcd10
bcd11:	SUBI	R30,-10
	ADD	R30,R31

;   (  )
	MOV	R31,R30
	ANDI	R31,0xF0
	BRNE	no_zero
	SWAP	R30
	ORI	R30,0x0A

;     
no_zero:
	LDI	R16,0xFF
	LDI	R17,0xFF
	MOV	R15,R30	; ,  

; 
	SWAP	R30
	ANDI	R30,0xF
	LDI	R31,0
	SUBI	R30,LOW(-segment*2)
	SBCI	R31,HIGH(-segment*2)
	LPM
	SBRC	R0,0
	ANDI	R16,0x7F
	SBRC 	R0,1
	ANDI 	R16,0xDF
	SBRC	R0,2
	ANDI	R17,0xFB
	SBRC	R0,3
	ANDI	R16,0xEF
	SBRC	R0,4
	ANDI	R17,0xEF
	SBRC	R0,5
	ANDI	R16,0xFB
	SBRC	R0,6
	ANDI	R16,0xFE

; 
	MOV	R30,R15
	ANDI	R30,0x0F
	LDI	R31,0
	SUBI	R30,LOW(-segment*2)
	SBCI	R31,HIGH(-segment*2)
	LPM
	SBRC	R0,0
	ANDI	R16,0xFD
	SBRC	R0,1
	ANDI	R16,0xBF
	SBRC	R0,2
	ANDI	R17,0x7F
	SBRC	R0,3
	ANDI	R17,0xFD
	SBRC	R0,4
	ANDI	R16,0xF7
	SBRC	R0,5
	ANDI	R17,0xF7
	SBRC	R0,6
	ANDI	R17,0xFE

;   (    )
	MOV	R30,R15
	CPI	R30,0x0A
	BREQ	no_znak
	TST	R14
	LDI	R30,0x9F
	BREQ	znak_1
	LDI	R30,0xBF
znak_1:	AND	R17,R30

;  
no_znak:
	LDI	R30,16
next:	ROR	R17
	ROR	R16	;    
	BRCC	one
	SBI	PORTD,4
	RJMP	en
one:	CBI	PORTD,4

en:	SBI	PORTD,2	;
	CBI	PORTD,2

	DEC	R30
	BRNE	next

	SBI	PORTD,3	;   LS595
	CBI	PORTD,3

; 
	RJMP	begin

;*************************  ************************
;
;      8- .
;
wait_1:
	LDI	R30,0x1F
wait:	SBIW	R28,1
	BRNE	wait
	DEC	R30
	BRNE	wait
	RET

;  () DS1820(DS18S20)
;  - .
;: R30    ,  rom -  ROM 
search:
	CLR	R1	;    (R1== 0).
	CLR	R20	;  DS18S20
	LDI	R26, LOW(rom)
	LDI	R27, HIGH(rom)
h0:	MOV	R0, R1
	CLR	R1	;    (R1== 0).

	RCALL	init	;    ?

	TST	R30
	BREQ	exit	;  (R30= 0)...

	LDI	R23, 0xF0	; SEARCH ROM
	RCALL	write

	LDI	R21, 1		;   .
h1:	CP	R21, R0
	BRSH	h6	;BRCC	h6	; C==0  

	RCALL	read_bit
	SBRC	R30, 7
	RJMP	h2
	RCALL	read_bit
	SBRC	R30, 7
	RJMP	h3
	RCALL	sel_bit
	AND	R24, R25
	BRNE	h3
	MOV	R1, R21	;    .
	RJMP	h3
h2:	RCALL	read_bit
h3:	RCALL	sel_bit
	AND	R24, R25
	BREQ	h8
	RJMP	h4

h6:	RCALL	read_bit	;  ()
	SBRS	R30, 7
	RJMP	h9
	RCALL	read_bit	;  ()
	SBRS	R30, 7
	RJMP	h12
exit:	MOV	R30, R20	; 11 -   ( h6)
	RET

h9:	RCALL	read_bit	;  ()
	SBRC	R30, 7
	RJMP	h11
	CP	R21, R0		; 00 ( h6)
	BREQ	h12
	MOV	R1, R21		;    .
h11:	CLT			; 01 ( h6)
	RCALL	set_bit
h8:	CLR	R23
	RJMP	h5
h12:	SET			; 10 ( h6)
	RCALL	set_bit
h4:	LDI	R23, 1
h5:	RCALL	write_bit
h13:	INC	R21		; .
	CPI	R21, 65
	BRLT	h1

	INC	R20	;   .
	TST	R1	;      (..    ),
	BREQ	exit	; .

	LDI	R21, 9
h14:	LD	R30, X
	ADIW	R26, 9
	ST	X, R30
	SBIW	R26, 8
	DEC	R21
	BRNE	h14
	RJMP	h0

;
;
;
temperature_start:
	LDI	R26, LOW(rom)
	LDI	R27, HIGH(rom)
	RCALL	select
	TST	R30
	BREQ	t_1

	LDI	R23, 0x44		; CONVERT T
	RCALL	write

	SBI	ds1820_port, ds1820_bit		;  +5
	SBI	ds1820_ddr, ds1820_bit	;  = 1

	RET

;
;
;
temperature_read:
	CBI	ds1820_port, ds1820_bit		;  
	CBI	ds1820_ddr, ds1820_bit	;  = 0


	LDI	R26, LOW(rom)
	LDI	R27, HIGH(rom)
	RCALL	read_spd
	TST	R30
	BRNE	t_2
t_1:
	LDI	R31, 0xAA	;  
	RET
t_2:
	RCALL	init

	LDS	R31, pad + 1	;    (* 2).
	LDS	R30, pad

	TST	R31
	BREQ	t_3
	COM	R30	;    (   r31)
	INC	R30

t_3:	INC	R30	;     .
	LSR	R30	;   .
	RET

;
;
;
init:
	CLR	R30

	CBI	ds1820_port, ds1820_bit
	SBI	ds1820_ddr, ds1820_bit	;  = 0

	LDI	R24, 0xC0		; 480 
	LDI	R25, 0x03
m1:	SBIW	R24, 1
	BRNE	m1


	CBI	ds1820_ddr, ds1820_bit	; 

	LDI	R24, 0x25		; 14 
m2:	DEC	R24
	BRNE	m2

	SBIS	ds1820_pin, ds1820_bit	; / 
	RET

	LDI	R24, 0xB3		; 67 
m3:	DEC	R24
	BRNE	m3

	SBIS	ds1820_pin, ds1820_bit	;   = 0
	INC	R30


	LDI	R24, 0x3A		; 413 
	LDI	R25, 0x03
m4:	SBIW	R24, 1
	BRNE	m4

	RET

;
;
;
write:
	LDI	R22, 8
	CLR	R30
wri0:	RCALL	write_bit
	BRTC	wri1
	ROR	R23
	DEC	R22
	BRNE	wri0
	INC	R30
 wri1:	RET

;
;
;
write_bit:

	CLT
	SBI	ds1820_ddr, ds1820_bit

	LDI	R24, 0x5		; 2 
n1:	DEC	R24
	BRNE	n1

	SBRC	R23, 0
	CBI	ds1820_ddr, ds1820_bit

	LDI	R24, 0x23		; 13 
n2:	DEC	R24
	BRNE	n2

	SBIC	ds1820_pin, ds1820_bit
	RJMP	write_bit0
	SBRS	R23, 0
	RJMP	write_bit1
	RJMP	n5

;
;
;
write_bit0:
	SBRS	R23, 0
	RET
write_bit1:
	LDI	R24, 0xC8
n3:	DEC	R24
	BRNE	n3

	CBI	ds1820_ddr, ds1820_bit

	LDI	R24, 0x0D
n4:	DEC	R24
	BRNE	n4

	SET
n5:

	RET

;
;
;
read_bit:
	SBI	ds1820_ddr, ds1820_bit	; 

	LDI	R24, 0x05		; 2 
r_1:	DEC	R24
	BRNE	r_1


	CBI	ds1820_ddr, ds1820_bit	; 

	LDI	R24, 0x1D		; 11 
r_2:	DEC	R24
	BRNE	r_2

	CLC
	SBIC	ds1820_pin, ds1820_bit	; 
	SEC
	ROR	R30


	LDI	R24, 0xD5		; 80 
r_3:	DEC	R24
	BRNE	r_3

	RET

;
;
;
set_bit:
	RCALL	sel_bit
	BRTS	set_bit2
	COM	R25
	AND	R24, R25
	RJMP	set_bit3
set_bit2:
	OR	R24, R25
set_bit3:
	ST	Z, R24
	RET

;
;:  R21 -    ROM (1...64)
;	R26,R27 -   rom.
;: R24 -  .
;	R25 -    .
sel_bit:
	MOV	R30, R21
	DEC	R30
	MOV	R22, R30
	LSR	R30
	LSR	R30
	LSR	R30
	CLR	R31
	ADD	R30, R26
	ADC	R31, R27
	LD	R24, Z
	LDI	R25, 1
	ANDI	R22, 7
sel_bit0:
	BREQ	sel_bit1
	LSL	R25
	DEC	R22
	RJMP	sel_bit0
sel_bit1:
	RET

;
;
;
select:
	RCALL	init
	TST	R30
	BREQ	s1

	SBIW	R26, 0
	BREQ	s2

	LDI	R23, 0x55	; MATCH ROM
	RCALL	write

	LDI	R16, 0
s3:
	LD	R23, X+
	RCALL	write
	INC	R16
	CPI	R16, 8
	BRLO	s3

	RJMP	s4
s2:
	LDI	R23, 204	; SKIP ROM
	RCALL	write
s4:
	LDI	R30, 1
s1:
	RET

;
;
;
read_spd:
	RCALL	select
	TST	R30
	BREQ	sp_3
sp_1:
	LDI	R23, 0xBE		; READ SCRATCHPAD
	RCALL	write

	LDI	R16, 9		;  9 
	LDI	R26, LOW (pad)
	LDI	R27, HIGH (pad)
sp_2:
	LDI	R22, 8
read0:	RCALL	read_bit
	DEC	R22
	BRNE	read0

	ST	X+, R30

	DEC	R16
	BRNE	sp_2

	CLR	R30		; CRC
	LDI	R24, 9
	LDI	R22, 0x18
	LDI	R26, LOW (pad)
	LDI	R27, HIGH (pad)
crc0:	LDI	R25, 8
	LD	R31, X+
crc1:	MOV	R23, R31
	EOR	R23, R30
	ROR	R23
	BRCC	crc2
	EOR	R30, R22
crc2:	ROR	R30
	LSR	R31
	DEC	R25
	BRNE	crc1
	DEC	R24
	BRNE	crc0

	TST	R30	; CRC  (R30== 0),
	LDI	R30, 1	;     (R30== 1).
	BREQ	sp_3
	CLR	R30
sp_3:
	RET
